<!DOCTYPE html>
<html lang="en-us">
	<head>
		<!-- Global site tag (gtag.js) - Google Analytics -->
		<script async src="https://www.googletagmanager.com/gtag/js?id=UA-171055694-1"></script>
		<script>
			window.dataLayer = window.dataLayer || [];
			function gtag(){dataLayer.push(arguments);}
			gtag('js', new Date());

			gtag('config', 'UA-171055694-1');
		</script>

		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
		<title>%UNITY_WEB_NAME%</title>

		<link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png">
		<link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
		<link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
		<link rel="manifest" href="/site.webmanifest">
		<link rel="mask-icon" href="/safari-pinned-tab.svg" color="#67256a">
		<meta name="msapplication-TileColor" content="#b91d47">
		<meta name="theme-color" content="#39253a">

		<link href="https://fonts.googleapis.com/css2?family=Squada+One&display=swap" rel="stylesheet">

		<style>
			html {
				box-sizing: border-box;
			}
			*, *:before, *:after {
				box-sizing: inherit;
			}
			body {
				margin: 0;
				background: #000;
				font-family: "Arial", sans-serif;
				color: #FFF;
			}
			::selection {
				color: #fff;
				background: #a373a6;
			}
			a:link, a:visited {
				color: white;
			}

			/* ===============
			   HEADER / NAV BAR
			   =============== */
			header {
				visibility: hidden; /* Hide initially, JS will enable when game starts */
				z-index: 100;
				position: relative;
				height: 55px;
				width: 100%;
				background-color: #39253a;
				transition: background-color 1s ease-in-out;
			}
			#menuBar {
				margin: 0 auto;
				height: 100%;
				display: flex;
				flex-direction: row;
				justify-content: space-between;
				font-family: 'Squada One', 'Arial', sans-serif;

				opacity: 0; /* Will fade in when game starts */
				transition: opacity 1s ease-in-out;
			}
			.smallLogo {
				height: 100%;
			}
			.smallLogo img {
				height: 120%;
				transition: all 0.25s ease-in-out;
			}
			#gameUIContainer {
				display: flex;
				flex-direction: row;
				justify-content: center;
				color: #937395;
				transition: color 1s ease-in-out;
			}
			#heartsUIContainer, #levelUIContainer {
				display: flex;
				flex-direction: row;
				align-items: center;
				margin: 0 60px;
			}
			#heartsUIContainer {
				width: 160px;
			}
			#levelUIContainer {
				width: 180px;
			}
			#gameUIContainer p {
				font-size: 2.7em;
				white-space: nowrap;
				word-spacing: -0.1em;
			}
			.subscript {
				font-size: 0.45em;
			}
			.disabled {
				opacity: 0.4;
			}
			nav img {
				display: inline-block;
				margin-left: 10px;
				padding: 5px;
				width: 55px;
				height: 55px;
				border: none;
				outline: none;
				cursor: pointer;
				background: content-box;
				transition: all 0.25s ease-in-out;
			}
			nav img:hover {
				transform: scale(1.1);
			}
			
			/* ===============
			   CANVAS
			   =============== */
			#gameContainer {
				width: 100vw;
				/* Height dynamically set with JS */
				background: #000 !important;
			}
			#gameContainer > div:not([class]) {
				/* Unity injects an error message when viewed on phones. Hide it. */
				display: none;
			}
			canvas {
				width: 100%;
				height: 100%;
				display: block;
			}

			/* ===============
			   PROGRESS BAR
			   =============== */
			#progressContainer {
				position: relative;
			}
			.progress {
				margin: 1.5em;
				border: 1px solid white;
				width: 50vw;
				max-width: 1024px;
				display: none;
				transition: 0.5s;
			}
			.progress .full {
				margin: 2px;
				background: white;
				height: 1em;
				transform-origin: top left;
				transition: transform 1s ease-in-out;
			}
			#loader {
				z-index: 200;
				position: absolute;
				left: 0;
				top: 0;
				width: 100vw;
				height: 100vh;
				display: flex;
				flex-direction: column;
				align-items: center;
				justify-content: space-between;
				
				background-image: linear-gradient(0deg,#000 0%, #260d23 20%);
				background-position: center top;
				background-repeat: no-repeat;
				background-size: contain;

				transition: opacity 1s ease-in-out;
			}
			.spinner,
			.spinner:after {
				border-radius: 50%;
				width: 5em;
				height: 5em;
			}
			.spinner {
				margin: 10px;
				font-size: 10px;
				position: relative;
				text-indent: -9999em;
				border-top: 1.1em solid rgba(255, 255, 255, 0.2);
				border-right: 1.1em solid rgba(255, 255, 255, 0.2);
				border-bottom: 1.1em solid rgba(255, 255, 255, 0.2);
				border-left: 1.1em solid #ffffff;
				transform: translateZ(0);
				animation: spinner-spin 1.1s infinite linear;
			}
			@keyframes spinner-spin {
				0% {
					transform: rotate(0deg);
				}
				100% {
					transform: rotate(360deg);
				}
			}

			/* ===============
			   ERROR & INFO MESSAGES
			   =============== */
			.message {
				position: absolute;
				top: 0;
				left: 50%;
				-webkit-transform: translateX(-50%);
				transform: translateX(-50%);
				margin-top: 30px;
				padding: 15px 20px;
				z-index: 500;
				line-height: 1.4em;
				background-color: #111;
				border: 2px solid #ff427c;
				border-radius: 5px;
				box-shadow: 0 0 10px 2px black;
			}

			/* ===============
			   MISC
			   =============== */
			.largeLogo {
				margin-top: 9vh;
				max-width: 60vw;
				max-height: 40vh;
			}
			#controlsBoard {
				max-width: 45vw;
				max-height: 20vh;
				opacity: 0.8;
			}
			#startBtn {
				visibility: hidden;
				opacity: 0;
				/* Stay on top of progress bar when it's faded out */
				z-index: 1;
				
				/* Center button on top of progress bar */
				position: absolute;
				top: -10px;
				left: 50%;
				-webkit-transform: translateX(-50%);
				transform: translateX(-50%);
			}
			.button {
				display: block;
				border: 3px solid white;
				color: white;
				padding: 8px 18px;
				text-align: center;
				transition: all 0.2s ease-in-out, visibility 0s linear 0.5s;
			}
			.button:hover {
				cursor: pointer;
				background-color: white;
				color: black;
				transition-delay:0s;
			}
			.authorText {
				margin-bottom: 30px;
				text-align: center;
				color: #BDA6BB;
				line-height: 1.5em;
				font-size: 1em;
			}
			.visible {
				opacity: 1 !important;
			}
			.invisible {
				opacity: 0 !important;
			}

			/* ===============
			   HEADER THEMES
			   =============== */
			.headerBackgroundBrown {
				background-color: #3c262f;
			}
			.headerBackgroundBurgundy {
				background-color: #402138;
			}
			.headerBackgroundPurple {
				background-color: #3e2042;
			}
			.headerBackgroundViolet {
				background-color: #2b2039;
			}
			.headerTextBrown {
				color:#8e757f !important;
			}
			.headerTextBurgundy {
				color: #937395 !important;
			}
			.headerTextPurple {
				color: #937395 !important;
			}
			.headerTextViolet {
				color: #837495 !important;
			}

			/* ===============
			   ICON FONT FOR UI
			   =============== */
			@font-face {
				font-family: 'HeartlightUI';
				src:
					url('fonts/HeartlightUI.ttf?y0kd6q') format('truetype'),
					url('fonts/HeartlightUI.woff?y0kd6q') format('woff'),
					url('fonts/HeartlightUI.svg?y0kd6q#HeartlightUI') format('svg');
				font-weight: normal;
				font-style: normal;
				font-display: block;
			}

			[class^="icon-"], [class*=" icon-"] {
				/* use !important to prevent issues with browser extensions that change fonts */
				font-family: 'HeartlightUI' !important;
				font-style: normal;
				font-weight: normal;
				font-variant: normal;
				text-transform: none;
				line-height: 1;
				-webkit-font-smoothing: antialiased;
  				-moz-osx-font-smoothing: grayscale;
			}

			.icon-uiLevel:before {
				content: "\e900";
			}
			.icon-uiHeart:before {
				content: "\e901";
			}
			#gameUIContainer .icon {
				font-size: 0.7em;
				margin-right: 5px;
			}
		</style>
	</head>

	<body>
		<header>
			<div id="menuBar">
				<a href="#" class="smallLogo"><img src="images/logo.png" alt="Heartlight Logo"/></a>
				
				<div id="gameUIContainer">
					<div id="heartsUIContainer">
						<p>
							<span class="icon icon-uiHeart"></span>
							<span id="heartsCollectedText">0</span>
							<span class="subscript">of</span>
							<span id="totalHeartsText">0</span> 
						</p>
					</div>

					<div id="levelUIContainer">
						<p>
							<span class="icon icon-uiLevel"></span>
							<span id="currentLevelText">0</span>
							<span class="subscript">of</span>
							<span id="totalLevelsText">70</span> 
						</p>
					</div>
				</div>
		
				<nav>
					<img src="images/uiSettings.png" alt="Settings Button" id="settingsBtn" />
					<img src="images/uiFullscreen.png" alt="Fullscreen Button" id="fullscreenBtn" />
				</nav>
			</div>
		</header>

		<div id="gameContainer"></div>
		
		<div id="loader">		
			<img class="largeLogo" src="images/logo.png">
			<img id="controlsBoard" src="images/controlsBoard.png" alt="Controls Image"/>

			<div id="progressContainer">
				<div class="spinner"></div>
				<div class="progress">
					<div class="full"></div>
				</div>
				<h2 id="startBtn" class="button">Start</h2>
			</div>

			<p class="authorText">Heartlight 30th Anniversary Edition by Mike Yeates. A fan remake of the game Heartlight (1990) by Janusz Pelc.<br/>
				Level design, music and sound effects by Janusz Pelc. Game logic and visual assets recrafted from scratch.</p>
		</div>
		
	</body>

	<script src="%UNITY_WEBGL_LOADER_URL%"></script>
	<script>

		// Can't use constants which share the same name as an ID element in Safari - works with variables
		// https://stackoverflow.com/questions/40091136/cant-create-duplicate-variable-that-shadows-a-global-property
		LoadRandomBackdrop();

		var loader = document.querySelector("#loader");
		var gameContainer = document.querySelector("#gameContainer");
		var progressBarContainer = document.querySelector("#loader .progress");
		var progressSlider = document.querySelector("#loader .full");
		var header = document.querySelector('header');
		var menuBarContainer = document.querySelector('header #menuBar');
		var gameUIText = document.querySelector('#gameUIContainer');

		// Fetch UI labels which the UIControllerJSBridge will later use
		var heartsCollectedLabel = document.querySelector("#heartsCollectedText");
		var totalHeartsLabel = document.querySelector("#totalHeartsText");
		var currentLevelLabel = document.querySelector("#currentLevelText");
		var totalLevelsLabel = document.querySelector("#totalLevelsText");

		// Fetch buttons for event listeners
		var btnStart = document.querySelector("#startBtn");
		var btnFullscreen = document.querySelector("#fullscreenBtn");
		var btnSettings = document.querySelector("#settingsBtn");

		window.addEventListener("orientationchange", SetGameHeight, false);
		window.addEventListener("resize", SetGameHeight, false);
		window.onload = OnLoad(); 
		
		var gameInstance = UnityLoader.instantiate("gameContainer",
												   "%UNITY_WEBGL_BUILD_URL%",
												   { onProgress: UnityProgress,
													 compatibilityCheck: CompatabilityCheck,
													 Module: { onRuntimeInitialized: PreventRightClickMenu }
												   });

		function LoadRandomBackdrop() {
			var imageIndex = Math.floor((Math.random() * 8)) + 1; // Backdrop naming is 1-based
			document.querySelector("#loader").style.backgroundImage = "url('backdrops/backdrop" + imageIndex + ".jpg')";
		}

		function OnLoad() {
			SetGameHeight();
		}

		function SetGameHeight() {
			var gameHeight = window.innerHeight - menuBarContainer.offsetHeight;
			
			// Levels are are a 20x12 grid (5:3 ratio)
			// Calculate game width so header (logo and nav) can line up with vertical edges of level
			var gameWidth = gameHeight * (5.0 / 3.0);

			gameContainer.style.height = gameHeight + "px";
			menuBarContainer.style.width = gameWidth + "px";
		}

		function PreventRightClickMenu() {
			// https://answers.unity.com/questions/1285228/webgl-how-to-disable-right-click-browser-menu.html
			this.canvas.addEventListener("contextmenu", function (e) {
				e.preventDefault();
			});
		}
		
		function CompatabilityCheck(gameInstance, onsuccess, onerror) {
			if (!UnityLoader.SystemInfo.hasWebGL) {
				ShowErrorMessage("Your web browser does not support WebGL. Please update your browser or try on a different device.");
				onerror(); // Don't even attempt to start if browser doesn't support WebGL
			} else if (UnityLoader.SystemInfo.mobile) {
				ShowErrorMessage("Phones and tablets are not supported. Please use a desktop or laptop.");
				onerror();
			} else if (["Chrome"].indexOf(UnityLoader.SystemInfo.browser) == 0) {
				if(parseInt(UnityLoader.SystemInfo.browserVersion) < 57) { // Jan 2017 (first to support WebGL 2.0) 
					ShowErrorMessage("Oh no, your web browser is too old. Please <a href='https://www.google.com.au/chrome/' target='_blank'>update Chrome</a> to run Heartlight.");
				}
				onsuccess();
			} else if (["Firefox"].indexOf(UnityLoader.SystemInfo.browser) == 0) {
				if(parseInt(UnityLoader.SystemInfo.browserVersion) < 52) { // Jan 2017 (first to support WebGL 2.0)
					ShowErrorMessage("Oh no, your web browser is too old. Please <a href='https://www.mozilla.org/en-US/firefox/new/' target='_blank'>update Firefox</a> to run Heartlight.");
				}
				onsuccess();
			} else if (["Edge"].indexOf(UnityLoader.SystemInfo.browser) == 0) {
				if(parseInt(UnityLoader.SystemInfo.browserVersion) < 42) { // April 2018
					ShowErrorMessage("Oh no, your web browser is too old. Please <a href='https://www.microsoft.com/en-us/edge' target='_blank'>update Edge</a> to run Heartlight.");
				}
				onsuccess();
			} else if (["Safari"].indexOf(UnityLoader.SystemInfo.browser) == 0) {
				if(parseInt(UnityLoader.SystemInfo.browserVersion) < 11.0) { // March 2018 (High Sierra)
					ShowErrorMessage("Oh no, your web browser is too old. Please update Safari to run Heartlight.");
				}
				onsuccess();
			} else {
				onsuccess();
			}
		}

		function ShowErrorMessage(text) {
			loader.insertAdjacentHTML("beforeend", "<div class='message'>" + text + "</div>");
		}

		function UnityProgress(gameInstance, progress) {
			
			if (!gameInstance.Module) {
				return;
			}
		
			if (!gameInstance.progress) {
				progressBarContainer.style.display = "block";
				gameInstance.progress = progressBarContainer.querySelector(".full");
				loader.querySelector(".spinner").style.display = "none";
			}
			
			// Scale progress bar to show progress (bar is pivoted at top-left)
			gameInstance.progress.style.transform = `scaleX(${progress * 0.9})`;

			if (progress === 1 && !gameInstance.removeTimeout) {
				// Keep loading bar visible until Unity slash screen completes underneath
				gameInstance.removeTimeout = setTimeout(OnLoadingComplete, 2100); 
			}
		}

		function OnLoadingComplete() {

			// Hide game window and progress bar, show start button
			gameContainer.style.display = "none";

			// Append classes so CSS transitions animate the change
			progressBarContainer.className += " invisible";

			btnStart.style.visibility = "visible";
			btnStart.className += " visible";
			
			btnStart.addEventListener('click', OnStartButtonPressed, false);
		}

		function OnStartButtonPressed() {
			// User interacted with page, remove listener from start button
			btnStart.removeEventListener('click', OnStartButtonPressed);

			// Add listeners to menu buttons along top of game
			btnFullscreen.addEventListener('click', OnFullscreenButtonPressed, false);
			btnSettings.addEventListener('click', OnSettingsButtonPressed, false);

			// Tell Unity to start updating level (so physics doesn't start until level is showing)
			gameInstance.SendMessage('Game Manager', 'OnStartBtnPressed');
		
			gameInstance.SendMessage('Game Manager', 'InformOfBrowser', UnityLoader.SystemInfo.browser);

			// Hide loading screen and reveal game hiding underneath
			loader.style.display = "none";

			// Show header bar (no animation)
			document.querySelector('header').style.visibility = "visible";
			// Fade in elements sitting on top of header bar
			menuBarContainer.className += " visible";

			// Show game container
      		gameContainer.style.display = "flex";
		}

		function OnFullscreenButtonPressed() {
			gameInstance.SetFullscreen(1);
		}

		function OnSettingsButtonPressed() {
			gameInstance.SendMessage('Game Manager', 'ToggleMenuScreen');
		}

	</script>

</html>

